#include <Bounce2.h>
  #define pressed_long 2000               // долговременное нажатие = 2 секунды
  #define num_modes 5                     // максимальный номер режима

  const int led_r = 3;                    // Голубой  Объявляем константу и присваиваем ей значение 3(номер pin(вывода) на плате Ардуино).  
  const int led_g = 4;                    // Зелёный  Объявляем константу и присваиваем ей значение 4(номер pin(вывода) на плате Ардуино).
  const int led_b = 5;                    // Красный  Объявляем константу и присваиваем ей значение 5(номер pin(вывода) на плате Ардуино).
  
  const int BUTTON_PIN = 2;               // Объявляем константу для кнопки и присваиваем ей значение 2(номер pin(вывода) на плате Ардуино). 

 
short int max_mode = num_modes + 1;                     // вспомогательная переменная
 
Bounce bouncer = Bounce();                              //создаем экземпляр класса Bounce
 
unsigned long pressed_moment;                           // момент нажатия кнопки
int current_mode = 0;                                   // текущий режим
 
void setup()
{
  Serial.begin(9600);
  pinMode(led_b, OUTPUT);                               // Голубой cветодиод. Настраиваем вывод 3 Ардуино на Выход
  pinMode(led_g, OUTPUT);                               // Зелёный cветодиод. Настраиваем вывод 4 Ардуино на Выход
  pinMode(led_r, OUTPUT);                               // Красный cветодиод. Настраиваем вывод 5 Ардуино на Выход         
  pinMode(BUTTON_PIN, INPUT_PULLUP);                    // Кнопка. Настраиваем вывод 2 - в режиме Входа.  Включаем внутренний pull-up резистор   
  digitalWrite(BUTTON_PIN, HIGH);  
  bouncer .attach(BUTTON_PIN);                          // устанавливаем кнопку
  bouncer .interval(5);                                 // устанавливаем параметр stable interval = 5 мс
}
 
void loop()
{
 if (bouncer.update())                                  //если произошло событие
 { 
  if (bouncer.read()==0)                                //если кнопка нажата
  { 
    pressed_moment = millis();                          // запоминаем время нажатия
  }
  else
  {
    if((millis() - pressed_moment) < pressed_long)       // если кнопка была нажата кратковременно
   {
    current_mode++;                                     // увеличиваем счетчик текушего режима
    current_mode %= max_mode;                           // остаток от целочисленного деления
    if (current_mode == 0) current_mode = 1;            // режим меняется от 1 до num_modes
    switch(current_mode)
    {
      case 1:     // Красный
        Red(); 
        break;      
      case 2:     // Зелёный
        Green();
        break;      
      case 3:     // Синий
        Blue();
        break;
      case 4:     // Фиолетовый
        Purple();
        break;
      case 5:     // Бирюзовый
        Turquoise();
        break;
    }
   }
   else                                                 // кнопка удерживалась долго
   { 
    Dark();
    current_mode = 0; 
    pressed_moment = 0;                                 // обнуляем момент нажатия
   }
   Serial.println(millis() - pressed_moment < pressed_long);                        // выводим сообщение о текущем режиме
  }                      
  }

}


void Red(){
  digitalWrite(led_r, HIGH);   // зажигаем красный светодиод
  digitalWrite(led_g, LOW);    // гасим зелёный светодиод
  digitalWrite(led_b, LOW);    // гасим голубой светодиод
  return;
  }
  void Green(){
  digitalWrite(led_g, HIGH);   // зажигаем зелёный светодиод
  digitalWrite(led_b, LOW);    // гасим голубой светодиод
  digitalWrite(led_r, LOW);    // гасим красный светодиод
  return;
  }
 void Blue(){
  digitalWrite(led_b, HIGH);   // зажигаем голубой светодиод
  digitalWrite(led_g, LOW);    // гасим зелёный светодиод
  digitalWrite(led_r, LOW);    // гасим красный светодиод
  return;
  }
  void Purple(){
  digitalWrite(led_b, HIGH);   // зажигаем голубой светодиод
  digitalWrite(led_g, LOW);    // гасим зелёный светодиод
  digitalWrite(led_r, HIGH);    // гасим красный светодиод
  return;
  }
  void Turquoise(){
  digitalWrite(led_b, HIGH);   // зажигаем голубой светодиод
  digitalWrite(led_g, HIGH);   // гасим зелёный светодиод
  digitalWrite(led_r, LOW);    // гасим красный светодиод
  return;
  }
 void Dark(){
  digitalWrite(led_r, LOW);   // гасим красный  светодиод
  digitalWrite(led_g, LOW);    // гасим зелёный светодиод
  digitalWrite(led_b, LOW);    // гасим голубой светодиод
  return;
  }  
